// books.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <fstream>
#include <string>
#include <list>

using namespace std;
// this represents the generic object in the collection
class holding {
public:
	holding() {};
	holding(string n, int l, double c) { title = n; location = l; cost = c;}
	string get_title() { return title;}
	int get_location() { return location;};
	double get_cost() { return cost;}
	void set_title(string s) { title = s;}
	void set_location(int l) { location = l;}
	void set_cost( double c) { cost = c;}
	virtual void print()
	{
			cout << "Title: " << title;
			cout << " Cost: " << cost << " Location:" << location << endl;
	}

protected:
	string title;  // title
	int location;  // shelf number
	double cost;   // cost in dollars
}; // holding

class book : public holding {
public:
	book(string a, int p) {
		author = a; pages=p;
	}
	book(string a, int p, int loc, double c, string t) {
		author = a; pages=p;
		location = loc; cost = c; title = t;
	}
	int get_pages() { return pages;}
	string get_author() { return author;}
	void set_pages(int p) { pages = p;}
	void set_author(string a) { author = a;}
	void print() 
	{
			holding::print(); 
			cout << " written by " << author;
			cout << " with " << pages << " pages." << endl;
			cout << "----------------------" << endl;
	} 
protected:
	string author;
	int pages;
}; // book


class video : public holding {
public:
	video(string a, int p) {
		director = a; length=p;
	}
	video(string a, int p, int loc, double c, string t) {
		director = a; length=p;
		location = loc; cost = c; title = t;
	}
	int get_length() { return length;}
	string get_director() { return director;}
	void set_length(int p) { length = p;}
	void set_director(string a) { director = a;}
	void print() 
	{
		holding::print();
		cout << " Directed by " << director;
		cout << " length " << length << endl;
		cout << "----------------------" << endl;
	}
private:
	string director;
	int length;
}; // video


class library {
public:
	void load_data();
	void print_library();
private:
	list<holding *> L;  // container of stuff
}; // library

void
library::load_data() 
{
	ifstream datain;
	char type;
	string author,director,title;
	int pages,location,length;
	double cost;
	holding *h;

	datain.open("books.txt");
	if(!datain) {
		cerr << "file open failed" << endl;
		exit(1);
	}
	while(true) {
		datain >> type;
		if(datain.eof()) break;   // end of file
		getline(datain,title,'$');
		title.erase(0,1);  // delete leading newline
		datain >> location;
		datain >> cost;
		if(type == 'b') {
			getline(datain,author,'$');
			author.erase(0,1);  // delete leading newline
			datain >> pages;
			h = new book(author,pages,location,cost,title);
		}
		else {
			getline(datain,director,'$');
			director.erase(0,1);  // delete leading newline
			datain >> length;
			h = new video(director,length,location,cost,title);
		}
		L.push_back(h);
	} // read data
	datain.close();
} // load_data

void
library::print_library()
{
	cout << "\n" << "List of titles " << endl;
		list<holding *>::iterator ptr = L.begin();
		while(ptr != L.end()) {
			(*ptr)->print();
			ptr++;
		}
} // print_library

int main(int argc, char* argv[])
{
	library L;
	L.load_data();
	L.print_library();
	return 0;
}
